<?php
  //----------------------------------------------------------------------
  // JBudgetsMagic
  // JBudgetsMagic by Fernando Hidalgo - http://joomlamagic.es
  //----------------------------------------------------------------------

  //----------------------------------------------------------------------
  // Author: 	Fernando Hidalgo - http://joomlamagic.es
  // Copyright: copyright (C) 2009 - Fernando Hidalgo.
  // License: 	GNU/GPL, http://www.gnu.org/copyleft/gpl.html
  // Pack: 	JBudgetsMagic
  // File: 	install.helper.php
  //----------------------------------------------------------------------  
  
  //----------------------------------------------------------------------    
  // JBudgetsMagic is free software. This version may have been modified pursuant
  // to the GNU General Public License, and as distributed it includes or
  // is derivative of works licensed under the GNU General Public License or
  // other free or open source software licenses.  
  //----------------------------------------------------------------------

defined( '_JEXEC' ) or die( 'Restricted access' );

class bdgHelperInstall
{
	function getVersionLocal()
	{
		// Code from PhocaGallery component
		$folder = JPATH_ADMINISTRATOR .DS. 'components'.DS.'com_jbudgetsmagic';
		if (JFolder::exists($folder)) {
			$xmlFilesInDir = JFolder::files($folder, '.xml$');
		} else {
			$folder = JPATH_SITE .DS. 'components'.DS.'com_jbudgetsmagic';
			if (JFolder::exists($folder)) {
				$xmlFilesInDir = JFolder::files($folder, '.xml$');
			} else {
				$xmlFilesInDir = null;
			}
		}

		$xml_items = '';
		if (count($xmlFilesInDir))
		{
			foreach ($xmlFilesInDir as $xmlfile)
			{
				if ($data = JApplicationHelper::parseXMLInstallFile($folder.DS.$xmlfile)) {
					foreach($data as $key => $value) {
						$xml_items[$key] = $value;
					}
				}
			}
		}
		if (isset($xml_items['version']) && $xml_items['version'] != '' ) {
			$version['version'] = $xml_items['version'];
			$verjoomla = new JVersion();
			if ($verjoomla->RELEASE == '1.5') {
				$version['creationDate'] = $xml_items['creationdate'];
			} else {
				$version['creationDate'] = $xml_items['creationDate'];
			}
			return $version;
		} else {
			return '';
		}
	}

	function getVersionRemote()
	{
    	//code from JFusion component
		ob_start();
		$url = 'http://joomlacode.org/gf/project/jbudgetsmagic/scmsvn/?action=browse&path=%2F*checkout*%2Ftrunk%2Fcom_jbudgetsmagic.xml';
    	if(function_exists('curl_init')){
    		//curl is the preferred function
	        $crl = curl_init();
    		$timeout = 5;
        	curl_setopt ($crl, CURLOPT_URL,$url);
    		curl_setopt ($crl, CURLOPT_RETURNTRANSFER, 1);
	    		curl_setopt ($crl, CURLOPT_CONNECTTIMEOUT, $timeout);
    		$JVersionRaw = curl_exec($crl);
        	curl_close($crl);
    	} else {
		//get the file directly if curl is disabled
		    $JVersionRaw = file_get_contents($url);
	        if (!strpos($JVersionRaw, '<install')){
		    //file_get_content is often blocked by hosts, return an error message
			    //echo JText::_('CURL_DISABLED_ERROR1');
			    return -1;
	        }
		}

 		$parser = JFactory::getXMLParser('Simple');
	    	if ($parser->loadString($JVersionRaw)) {
        		if (isset( $parser->document )) {
				$JVersion    = $parser->document;
         		} else {
				    //echo JText::_('CURL_DISABLED_ERROR2');
				    return -2;
         		}
		}
		unset($parser);
		ob_end_clean();
	
		$version['version'] = $JVersion->version[0]->data();
		$version['creationDate'] = $JVersion->creationDate[0]->data();
		return $version;
	}

	function _sql($sql) {
		jimport('joomla.filesystem.file');
		$sql_file = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jbudgetsmagic'.DS. 'sql' . DS . $sql . '.sql';
		$sql_query = JFile::read($sql_file);
		$db =& JFactory::getDBO();
		$db->setQuery($sql_query);
		if (!$db->queryBatch()){
			$msg = '<table bgcolor="#f9d9d2" width ="100%"><tr style="height:30px"><td>';
			$msg .= '<td><b>' . JText::_('COM_JBUDGETSMAGIC_SQL_UPDATE_ERROR') . ' ' . $db->stderr() . '</b></font></td></tr></table>';
		} else {
			$msg = '<table bgcolor="#d9f9e2" width ="100%"><tr style="height:30px"><td>';
			$msg .= '<td><b>' . JText::_('COM_JBUDGETSMAGIC_SQL_UPDATE_SUCESS') . ' ' . $sql . '</b></font></td></tr></table>';
			echo $msg;
		}
	}

	function sqldiff($local, $remote) {
		$files = JFolder::files(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jbudgetsmagic'.DS .'sql');
		foreach ($files as $f) {
			if (!substr($f,12,1)) {
				$actual = substr($f,0,8);
				if ((($actual > $local) && ($actual <= $remote)) || ($local == NULL) || ($local == "")) {
					bdgHelperInstall::_sql($actual);
				}
			}
		}
	}

	function datetosql($date) {
		return substr($date,6,4) . substr($date,3,2) . substr($date,0,2);
	}

    function checks() {
        // Initialization
        $checks->errors = null;
        $checks->upgrades = null;
        $checks->success = null;
        $checks->warnings = null;

        // Check Conexion
        $vremote = bdgHelperInstall::getVersionRemote();
        $vlocal = bdgHelperInstall::getVersionLocal();
        if ($vremote == -1) {
            $ckecks->warnings[] = 'file_get_contents';
        } elseif ($vremote == -2) {
            $checks->warnings[] = 'conexion';
        } else {
            $checks->success[] = 'conexion';
            if ($vremote['version'] > $vlocal['version']) {
                $checks->upgrades[] = 'upgrade';
            } else {
                $checks->success[] = 'upgrade';
            }
        }

        // Check Link CreateBudget
        $db = &JFactory::getDBO();
        $query = "SELECT * FROM #__menu WHERE link = 'index.php?option=com_jbudgetsmagic&view=form' AND published = 1";
        $db->setQuery($query);
        $link = $db->loadObjectList();
        if (count($link) > 0) {
            $checks->success[] = 'link';
        } else {
            $checks->warnings[] = 'link';
        }

        // Check GTMagic conexion
        if (bdgHelperConfig::getConfig('select_colors', 'default') == 0) {
            jimport('joomla.filesystem.file');
            $gtmagic_fw = JPATH_ROOT . DS . 'components' . DS . 'com_gtmagic' . DS . 'helpers' . DS . 'framework.helper.php';
            if (JFile::exists($gtmagic_fw)) {
                $checks->success[] = 'gtmagic';
            } else {
                $checks->warnings[] = 'gtmagic';
            }
        }

        // Check Version
        $version = new JVersion();
        if ($version->RELEASE == '1.5' && $version->DEV_LEVEL < 6) {
            $checks->errors[] = 'version';
        } else {
            $checks->success[] = 'version';
        }

        // Check Mootools
        /* $version = new JVersion();
        if ($version->RELEASE == '1.5' && $version->DEV_LEVEL >= 19 && JPluginHelper::isEnabled( 'system', 'mtupgrade' ) ) {
            $checks->success[] = 'mootools';
        } else {
            $checks->errors[] = 'mootools';
        }*/
        return $checks;
    }
}
