<?php
  //----------------------------------------------------------------------
  // JBudgetsMagic
  // JBudgetsMagic by Fernando Hidalgo - http://joomlamagic.es
  //----------------------------------------------------------------------

  //----------------------------------------------------------------------
  // Author: 	Fernando Hidalgo - http://joomlamagic.es
  // Copyright: copyright (C) 2009 - Fernando Hidalgo.
  // License: 	GNU/GPL, http://www.gnu.org/copyleft/gpl.html
  // Pack: 	JBudgetsMagic
  // File: 	budgets.php
  //----------------------------------------------------------------------  
  
  //----------------------------------------------------------------------    
  // JBudgetsMagic is free software. This version may have been modified pursuant
  // to the GNU General Public License, and as distributed it includes or
  // is derivative of works licensed under the GNU General Public License or
  // other free or open source software licenses.  
  //----------------------------------------------------------------------

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class bdgModelBudgets extends JModel
{
	var $_data;
	
	function _buildQuery()
	{
		$where = array();
		if (($this->filter_state != 'All') && ($this->filter_state != '')) {
			$where[] = "state = '".$this->filter_state."'";
		}

		if ($this->search)
		{
			$where[] = 'LOWER(name) LIKE \''. $this->search. '\'';
		}

		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

		$orderby = "";
		if (($this->filter_order != 'title') && ($this->filter_order != 'description') && ($this->filter_order != 'user_id') && ($this->filter_order != 'state') && ($this->filter_order != 'upload') && ($this->filter_order != 'id')) $this->filter_order = '';
		if (($this->filter_order) && ($this->filter_order_Dir))
			$orderby 	= ' ORDER BY '. $this->filter_order .' '. $this->filter_order_Dir;

		$this->_query = ' SELECT *'
				. ' FROM #__bdg_budgets '
				. $where
				. $orderby
				;

        	return $this->_query;	
	}
	

	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();
		$mainframe = &JFactory::getApplication();
		$option = JRequest::getCmd('option');

		$this->filter_order	= $mainframe->getUserStateFromRequest( "$option.filter_order", 'filter_order', '', 'word' );
		$this->filter_order_Dir	= $mainframe->getUserStateFromRequest( "$option.filter_order_Dir", 'filter_order_Dir', '', 'word' );
		$this->filter_state	= $mainframe->getUserStateFromRequest( "$option.filter_state",	'filter_state',	'', 'word' );
		$this->search		= $mainframe->getUserStateFromRequest( "$option.search", 'search', '', 'string' );
		$this->search		= JString::strtolower( $this->search );

		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getData() 
	{
 		if (empty($this->_data)) {
			$query = $this->_buildQuery();
 	    		$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}	

	function getList()
	{
		// state filter
		$comboState[]		= JHTML::_('select.option',  'All', JText::_( 'COM_JBUDGETSMAGIC_SELECT_STATE' ), 'id', 'title' );
		$comboState[]		= JHTML::_('select.option',  'New', JText::_( 'COM_JBUDGETSMAGIC_NEW' ), 'id', 'title' );
		$comboState[]		= JHTML::_('select.option',  'Opened', JText::_( 'COM_JBUDGETSMAGIC_OPENED' ), 'id', 'title' );
		$comboState[]		= JHTML::_('select.option',  'Cancelled', JText::_( 'COM_JBUDGETSMAGIC_CANCELLED' ), 'id', 'title' );
		$comboState[]		= JHTML::_('select.option',  'Approved', JText::_( 'COM_JBUDGETSMAGIC_APPROVED' ), 'id', 'title' );
		
		$javascript = 'onchange="document.adminForm.submit();"';
		$lists['state']		= JHTML::_('select.genericlist',   $comboState, 'filter_state', 'class="inputbox" size="1"'.$javascript,'id', 'title', $this->filter_state );

		// table ordering
		$lists['order_Dir']	= $this->filter_order_Dir;
		$lists['order']		= $this->filter_order;


		// search filter
		$lists['search']= $this->search;
		
		return $lists;
	}

	function getTotal()
	{
		// Load the content if it doesn't already exist
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);	
		}
		return $this->_total;
	}

	function getPagination()
	{
		// Load the content if it doesn't already exist
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
}
